//
//Welcome to app.js
//This is main application config of project. You can change a setting of :
//  - Global Variable
//  - Theme setting
//  - Icon setting
//  - Register View
//  - Spinner setting
//  - Custom style
//
//Global variable use for setting color, start page, message.
var db = null; //Use for SQLite database.
window.globalVariable = {
    //custom color style variable
    color: {
        appPrimaryColor: "",
        dropboxColor: "#017EE6",
        facebookColor: "#3C5C99",
        foursquareColor: "#F94777",
        googlePlusColor: "#D73D32",
        instagramColor: "#517FA4",
        wordpressColor: "#0087BE"
    },// End custom color style variable
    startPage: {
        url: "app/login",//Url of start page.
        state: "app.login"//State name of start page.
    },
    message: {
        errorMessage: "Technical error please try again later." //Default error message.
    }
};// End Global variable
// "PlaystoreLink":"https://play.google.com/store/apps/details?id=com.codingtrickshub.passwordsmanager.free",
var CONSTANTS = {
    "ApplicationType":"Paid",
    "MaxCategoriesAllowed":1,
    "MaxPasswordsAllowed":5,
    "MaxSecureNotesAllowed":5,
    "PlaystoreLink":"https://play.google.com/store/apps/details?id=com.codingtrickshub.passwordsmanager",
    "PlaystoreLinkPaid":"https://play.google.com/store/apps/details?id=com.codingtrickshub.passwordsmanager",
}


angular.module('starter', ['ionic','ngIOS9UIWebViewPatch', 'starter.controllers', 'starter.services', 'ngMaterial', 'ngMessages', 'ngCordova','mdo-angular-cryptography','angular-md5','pascalprecht.translate'])
    .run(function ($ionicPlatform, $cordovaSQLite, $rootScope, $ionicHistory, $state, $mdDialog, $mdBottomSheet) {
        
        // $rootScope.showMenu = true;

        // $rootScope.goBack = function () {
        //     $ionicHistory.goBack(-1);
        //     // var historyStack = $ionicHistory.viewHistory();
        //     // if (historyStack.backView.stateName == 'app.registerPatternLock')
        //     // {
        //     // }
        //     // else {
        //     //   $ionicHistory.goBack(-1);
        //     // }
        //   };

        // $rootScope.$on('$stateChangeSuccess', function() {
        //     if($state.current.name == 'app.login')
        //     {
        //         $rootScope.showMenu = false;
        //     }
        //     else
        //     {
        //         $rootScope.showMenu = true;
        //     }        
        //   });
        
        //   initialSQLite();
        //Create database table of contracts by using sqlite database.
        //Table schema :
        //Column	   Type	     Primary key
        //  id	        Integer	    Yes
        //  firstName	Text	    No
        //  lastName	Text	    No
        //  telephone	Text	    No
        //  email	    Text	    No
        //  note	    Text	    No
        //  createDate	DateTime	No
        //  age	        Integer	    No
        //  isEnable	Boolean	    No

        function initialSQLite() {

            db = window.cordova ? $cordovaSQLite.openDB({name:"SecureBox.db",location:'default'}) : window.openDatabase("SecureBox.db", "1", "SecureBoxDB", 1024 * 1024 * 100);

            $cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS Categories (Id integer primary key, Category_Name text, Parent_Category_Id integer, Url text)");
            $cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS Passwords (Id integer primary key, Username_Email text, Password text,Category_Id integer)");
            $cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS Settings (Id integer primary key, Setting_Name text, Setting_Value text)");
            $cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS ImportData (Id integer primary key, Username_Email text, Password text,Category_Id integer,Category_Name text,Url text,Parent_Category_Id integer)");
            // ,Category_Id integer DEFAULT 0
            // ,Favourite boolean
            $cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS Notes (Id integer primary key, Title text, Note text)");
            $cordovaSQLite.execute(db, "INSERT INTO Categories(Category_Name,Parent_Category_Id,Url) SELECT 'Passwords Manager' as 'Category_Name' , 0 as 'Parent_Category_Id' , 'passwords-manager.com' as 'Url' where 1 > (SELECT count(*) as 'count' from Categories)");
            $cordovaSQLite.execute(db, "INSERT INTO Settings(Setting_Name,Setting_Value) Select 'KEY_TYPE','1' where 1 > (SELECT count(*) from Settings where setting_name = 'KEY_TYPE') and 0 < (select count(*) from settings)");
            $cordovaSQLite.execute(db, "Alter Table 'Passwords' add 'Note' varchar null default ''");
            $cordovaSQLite.execute(db, "Alter Table 'ImportData' add 'Note' text null default ''");
            $cordovaSQLite.execute(db, "Alter Table 'ImportData' add 'Title' text null default ''");
        
        };
        // End creating SQLite database table.

        // Create custom defaultStyle.
        function getDefaultStyle() {
            return "" +
                ".material-background-nav-bar { " +
                "   background-color        : " + appPrimaryColor + " !important; " +
                "   border-style            : none;"+
                "   color:white;" +
                "}" +
                ".md-primary-color {" +
                "   color                     : " + appPrimaryColor + " !important;" +
                "}";
        }// End create custom defaultStyle

        function initialRootScope() {
            $rootScope.appPrimaryColor = appPrimaryColor;// Add value of appPrimaryColor to rootScope for use it to base color.
            $rootScope.isAndroid = ionic.Platform.isAndroid();// Check platform of running device is android or not.
            $rootScope.isIOS = ionic.Platform.isIOS();// Check platform of running device is ios or not.
        };

        function hideActionControl() {
            //For android if user tap hardware back button, Action and Dialog should be hide.
            $mdBottomSheet.cancel();
            $mdDialog.cancel();
        };


        // createCustomStyle will change a style of view while view changing.
        // Parameter :
        // stateName = name of state that going to change for add style of that page.
        function createCustomStyle(stateName) {
            var customStyle =
                ".material-background {" +
                "   background-color          : " + appPrimaryColor + " !important;" +
                "   border-style              : none;" +
                "   color:white !important;" +
                "}" +
                ".spinner-android {" +
                "   stroke                    : " + appPrimaryColor + " !important;" +
                "}";

            switch (stateName) {
                case "app.Login" :
                    customStyle += getDefaultStyle();
                    break;
                default:
                    customStyle += getDefaultStyle();
                    break;
            }
            return customStyle;
        }// End createCustomStyle

        // Add custom style while initial application.
        $rootScope.customStyle = createCustomStyle(window.globalVariable.startPage.state);

        $ionicPlatform.ready(function () {
            ionic.Platform.isFullScreen = true;
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);
            }
            if (window.StatusBar) {
                StatusBar.styleDefault();
            }


            initialSQLite();
            initialRootScope();
            


            //Checking if view is changing it will go to this function.
            $rootScope.$on('$ionicView.beforeEnter', function () {
                //hide Action Control for android back button.
                hideActionControl();
                // Add custom style ti view.
                $rootScope.customStyle = createCustomStyle($ionicHistory.currentStateName());
            });           
        });

    })

    .config(function ($ionicConfigProvider, $stateProvider, $urlRouterProvider, $mdThemingProvider, $mdIconProvider, $mdColorPalette,$translateProvider) {

        

        // ,$translateProvider
        $translateProvider.useStaticFilesLoader({
            prefix: './templates/languages/',
            suffix: '.json'
            });
       
        var deviceLanguage = navigator.language;
        var EnglishLanguages = ["en-US", "en", "en-AU", "en-CA", "en-IN", "en-NZ", "en-ZA", "en-GB"];
        var GermanLanguages = ["de", "de-AT", "de-DE", "de-LI", "de-CH"];
        var Spanish = ["es", "es-AR", "es-CL", "es-CO", "es-CR", "es-HN", "es-419", "es-MX", "es-PE", "es-ES", "es-US", "es-UY", "es-VE"];
        var PortugueseLanguages = ["pt","pt-BR","pt-PT"];
        var Italian = ["it", "it-IT", "it-CH"];
        var Russian = ["ru"];
        
        // if(GermanLanguages.indexOf(navigator.language) > -1)
        // {
        //     deviceLanguage = 'de';
        // }
        // else 
        if(PortugueseLanguages.indexOf(navigator.language) > -1)
        {
            deviceLanguage = 'pt';
        }        
        if(Spanish.indexOf(navigator.language) > -1)
        {
            deviceLanguage = 'es';
        }
        if(Italian.indexOf(navigator.language) > -1)
        {
            deviceLanguage = 'it';
        }
        if(Russian.indexOf(navigator.language) > -1)
        {
            deviceLanguage = 'ru';
        }
        else
        {
            deviceLanguage = 'en';
        }

        if(!window.localStorage['LANGUAGE'])
        {
            window.localStorage['LANGUAGE'] = deviceLanguage;
        }

        $translateProvider.preferredLanguage(window.localStorage['LANGUAGE']);
        $translateProvider.fallbackLanguage('en');
        //// $translateProvider.determinePreferredLanguage();
        $translateProvider.useSanitizeValueStrategy('escapeParameters');

        // Use for change ionic spinner to android pattern.
        $ionicConfigProvider.spinner.icon("android");
        $ionicConfigProvider.views.swipeBackEnabled(false);

        // mdIconProvider is function of Angular Material.
        // It use for reference .SVG file and improve performance loading.
        $mdIconProvider
            .icon('facebook', 'img/icons/facebook.svg')
            .icon('twitter', 'img/icons/twitter.svg')
            .icon('mail', 'img/icons/mail.svg')
            .icon('message', 'img/icons/message.svg')
            .icon('share-arrow', 'img/icons/share-arrow.svg')
            .icon('more', 'img/icons/more_vert.svg');

        //mdThemingProvider use for change theme color of Ionic Material Design Application.
        /* You can select color from Material Color List configuration :
         * red
         * pink
         * purple
         * purple
         * deep-purple
         * indigo
         * blue
         * light-blue
         * cyan
         * teal
         * green
         * light-green
         * lime
         * yellow
         * amber
         * orange
         * deep-orange
         * brown
         * grey
         * blue-grey
         */
        //Learn more about material color patten: https://www.materialpalette.com/
        //Learn more about material theme: https://material.angularjs.org/latest/#/Theming/01_introduction
        $mdThemingProvider
            .theme('default')
            .primaryPalette('pink')
            .accentPalette('red');

        appPrimaryColor = $mdColorPalette[$mdThemingProvider._THEMES.default.colors.primary.name]["500"]; //Use for get base color of theme.

        //$stateProvider is using for add or edit HTML view to navigation bar.
        //
        //Schema :
        //state_name(String)      : Name of state to use in application.
        //page_name(String)       : Name of page to present at localhost url.
        //cache(Bool)             : Cache of view and controller default is true. Change to false if you want page reload when application navigate back to this view.
        //html_file_path(String)  : Path of html file.
        //controller_name(String) : Name of Controller.
        //
        //Learn more about ionNavView at http://ionicframework.com/docs/api/directive/ionNavView/
        //Learn more about  AngularUI Router's at https://github.com/angular-ui/ui-router/wiki
        $stateProvider
            .state('app', {
                url: "/app",
                abstract: true,
                templateUrl: "templates/html/menu/menu.html",
                controller: 'menuCtrl'
            })
            .state('app.category', {
                cache: false,
                url: "/category/:parentCategoryId",
                params:{
                    isAnimated:false
                },
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/category/category.html",
                        controller: 'categoryCtrl'
                    }
                }
            })
            .state('app.password', {
                cache: false,
                url: "/password/:passwordCategoryId",
                params:{
                    isAnimated:false
                },
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/password/password.html",
                        controller: 'passwordCtrl'
                    }
                }
            })
            .state('app.secureNotes', {
                cache: false,
                url: "/secureNotes",
                params:{
                    isAnimated:false
                },
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/secure-notes/secure-notes.html",
                        controller: 'secureNotesCtrl'
                    }
                }
            })            
            .state('app.aboutUs', {
                url: "/aboutUs",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/about-us/about-us.html", 
                        controller: 'aboutUsCtrl'
                    }

                }
            })
            .state('app.privacyPolicy', {
                url: "/privacyPolicy",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/privacy-policy/privacy-policy.html", 
                        controller: 'privacyPolicyCtrl'
                    }
                }
            })            
            .state('app.contactUs', {
                url: "/contactUs",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/contact-us/contact-us.html", 
                        controller: 'contactUsCtrl'
                    }

                }
            })
            .state('app.categoriesHierarchy', {
                url: "/categoriesHierarchy",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/categories-hierarchy/categories-hierarchy.html", 
                        controller: 'categoriesHierarchyCtrl'
                    }

                }
            })
            .state('app.import', {
                url: "/import",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/import/import.html", 
                        controller: 'importCtrl'
                    }

                }
            })
            .state('app.export', {
                cache: false,
                url: "/export",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/export/export.html", 
                        controller: 'exportCtrl'
                    }

                }
            })
            .state('app.settings', {
                cache: false,
                url: "/settings",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/settings/settings.html", 
                        controller: 'settingsCtrl'
                    }

                }
            })
            .state('app.changeSecurityKey', {
                cache: false,
                url: "/changeSecurityKey",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/change-security-key/change-security-key.html", 
                        controller: 'changeSecurityKeyCtrl'
                    }

                }
            })
            .state('app.registerSecurityKey', {
                cache: false,
                url: "/registerSecurityKey",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/register-security-key/register-security-key.html", 
                        controller: 'registerSecurityKeyCtrl'
                    }

                }
            })
            .state('app.passwordGenerator', {
                cache: false,
                url: "/passwordGenerator",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/password-generator/password-generator.html", 
                        controller: 'passwordGeneratorCtrl'
                    }

                }
            })
            .state('app.introSlider', {
                cache: false,
                url: "/introSlider",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/intro-slider/intro-slider.html", 
                        controller: 'introSliderCtrl'
                    }

                }
            })
            .state('app.faq', {
                cache: false,
                url: "/faq",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/faq/faq.html", 
                        controller: 'faqCtrl'
                    }

                }
            })
            
            .state('app.login', {
                cache: false,
                url: "/login",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/login/login.html",
                        controller: 'loginCtrl'
                    }

                }
            })
            .state('app.forgetSecurityKey', {
                cache: false,
                url: "/forgetSecurityKey",
                views: {
                    'menuContent': {
                        templateUrl: "templates/html/forget-security-key/forget-security-key.html",
                        controller: 'forgetSecurityKeyCtrl'
                    }

                }
            })
                        
            if(!window.localStorage['INTRO_KEY'])
            {
                $urlRouterProvider.otherwise('app/introSlider'); 
                
            }
            else if(!window.localStorage['USER_KEY'])
            {
                $urlRouterProvider.otherwise('app/registerSecurityKey');                           
            }
            else
            {
                $urlRouterProvider.otherwise(window.globalVariable.startPage.url);                           
            }

            
                    
        
    });
